<?php
namespace JchOptimize\Core\libs;

class JchOptimizeMe {

    /**
     * Your plugin or theme name. It will be used in admin notices
     * @var mixed
     */
    private $name;
    /**
     * Registration page slug
     * @var mixed
     */
    private $slug;
    /**
     * Parent menu slug
     * More info: https://developer.wordpress.org/reference/functions/add_submenu_page/
     * @var mixed
     */
    private $parent_slug;
    /**
     * Your plugin or theme text domain
     * This wil be used to translate Zhaket Guard SDK strings with you theme or plugin translation file
     * @var mixed
     */
    private $text_domain;
    /**
     * Name of option that save info
     * @var mixed
     */
    private static $option_name;
    private static $id;
    /**
     * Your product token in zhaket.com
     * @var mixed
     */
    private $product_token;
    /**
     * Zhaket guard API url
     * @var string
     */
    public static $api_url = 'uggcf://thneq.munxrg.pbz/ncv/';

    /**
     * Single instance of class
     * @var null
     */
    private static $instance = null;

    /**
     * JchOptimizeMe constructor.
     */
    public function __construct() {

        // Initial settings
        $defaults = [
            'name'          => 'JCH Optimize Pro',
            'slug'          => 'JchOptimizeMe',
            'parent_slug'   => 'options-general.php',
            'text_domain'   => 'jch-optimize',
            'product_token' => 'a8d18180-9233-4a59-bdb7-5f0ac28a0174',
            'option_name'   => 'JchOptimizeMe_settings'
        ];

        $this->name = $defaults['name'];
        $this->slug = $defaults['slug'];
        $this->parent_slug = $defaults['parent_slug'];
        $this->text_domain = $defaults['text_domain'];
        self::$option_name = $defaults['option_name'];
        self::$id = str_rot13(strrev('676q034n8op8s3736np30n0oo8015rs4'));
        $this->product_token = $defaults['product_token'];

        add_action('admin_menu', array($this, 'admin_menu'));

        add_action('wp_ajax_'.$this->slug, array($this, 'wp_starter'));

        add_action('wp_ajax_'.$this->slug.'_revalidate', array($this, 'revalidate_starter'));

        add_action('init', array($this, 'schedule_programs'));

        add_action( $this->slug.'_daily_validator', array($this, 'daily_event') );

        add_action( 'admin_notices', array($this, 'admin_notice') );
        remove_action('admin_menu', 'add_jch_optimize_menu',10);
        add_action('admin_menu', [$this,'add_jch_optimize_menu'],10);
        if (self::is_activated()){
            add_filter('option_jch_options',[$this,'clear_option'],10,2);
//            remove_action('sanitize_option_jch_options','jch_options_validate',10);
//            add_action('sanitize_option_jch_options',[$this,'sanitize_option_jch_options'],10,1);
        }
    }

    function clear_option($value, $option ){
        if (isset($_GET['jch-task']) || (isset($_GET['action']) && $_GET['action']==='optimizeimages') ){
            $value['pro_downloadid']=self::$id;
        }else{
            $value['pro_downloadid']='*************************';
        }
        return $value;
    }

    public static function pro_downloadid($id){
        if (self::is_activated()){
            return self::$id;
        }else{
            return $id;
        }
    }
    function sanitize_option_jch_options($input){
        $input['pro_downloadid']=self::$id;
        return $input;
    }
    function add_jch_optimize_menu()
    {
        $hook_suffix = add_options_page(__('JCH Optimize Pro Settings', 'jch-optimize'), 'JCH Optimize Pro', 'manage_options', 'jchoptimize-settings',
            [$this,'jch_options_page']);

        add_action('admin_enqueue_scripts', 'jch_load_resource_files');
        add_action('admin_head-' . $hook_suffix, 'jch_load_scripts');
        add_action('load-' . $hook_suffix, 'jch_initialize_settings');
    }

    function jch_options_page()
    {
        if (version_compare(PHP_VERSION, '5.3.0', '<'))
        {

            ?>

            <div class="notice notice-error">
                <p> <?php _e('This plugin requires PHP 5.3.0 or greater to run. Your installed version is: ' . PHP_VERSION, 'jch-optimize') ?></p>
            </div>
            <?php

        }

        ?>
        <div>
            <h2>JCH Optimize Pro Settings</h2>
            <form action="options.php" method="post" class="jch-settings-form">
                <div style="width: 90%;">
                    <input name="Submit" type="submit" class="button button-primary"
                           value="<?php esc_attr_e('Save Changes', 'jch-optimize'); ?>"/>
                    <?php
                    $subscribe_url = 'https://www.jch-optimize.net/subscribe/levels.html/#wordpress';
                    /* ##<freecode>##
                      ?>
                      <a class="right button button-secondary" href="<?php echo $subscribe_url; ?>" target="_blank"><?php _e('Upgrade to Pro', 'jch-optimize'); ?></a>

                      <?php
                      ##<freecode>## */

                    ?>

                </div>
                <!-- Nav tabs -->
                <ul class="nav nav-tabs">
                    <li class="active">
                        <a href="#description" data-toggle="tab">
                            <?php _e('Description', 'jch-optimize') ?>
                        </a>
                    </li>

                    <?php

                    if (version_compare(PHP_VERSION, '5.3.0', '>='))
                    {

                        ?>

                        <li>
                            <a href="#basic" data-toggle="tab">
                                <?php _e('Combine CSS/JS', 'jch-optimize') ?>
                            </a>
                        </li>
                        <li>
                            <a href="#exclude" data-toggle="tab">
                                <?php _e('Exclude Options', 'jch-optimize') ?>
                            </a>
                        </li>
                        <li>
                            <a href="#sprite" data-toggle="tab">
                                <?php _e('Basic Features', 'jch-optimize') ?>
                            </a>
                        </li>
                        <li>
                            <a href="#pro" data-toggle="tab">
                                <?php _e('Advanced Features', 'jch-optimize') ?>
                            </a>
                        </li>
                        <li>
                            <a href="#images" data-toggle="tab">
                                <?php _e('Optimize Images', 'jch-optimize') ?>
                            </a>
                        </li>
                        <li>
                            <a href="<?php echo admin_url( 'admin.php?page='.$this->slug ) ?>">
                                <?php _e('license activation', 'jch-optimize') ?>
                            </a>
                        </li>
                        <?php

                    }

                    ?>
                </ul>

                <!-- Tab panes -->
                <div class="tab-content">

                    <div class="tab-pane active" id="description">
                        <div id="extension-container" style="text-align:right;">
                            <h1>JCH Optimize Pro Plugin</h1>
                            <h3>(Version pro-2.7.0)</h3>
                            <p><?php _e('This plugin speeds up your website by performing a number of front end optimizations to your website automatically. These optimizations reduce both your webpage size and the number of http requests required to download your webpages and results in reduced server load, lower bandwidth requirements, and faster page loading times.', 'jch-optimize') ?></p>
                            <p><img src="<?php echo JCH_PLUGIN_URL ?>/logo.png"
                                    style="float: none"/></p>
                            <h2><?php _e('Major Features', 'jch-optimize') ?></h2>
                            <ul>
                                <li><?php _e('Combine and gzip CSS and javascript files', 'jch-optimize') ?></li>
                                <li><?php _e('Minify combined files and HTML', 'jch-optimize') ?></li>
                                <li><?php _e('Combine select background images into a sprite', 'jch-optimize') ?></li>
                                <li><?php _e('Page cache', 'jch-optimize') ?></li>
                                <li><?php _e('CDN support', 'jch-optimize') ?></li>
                                <li><?php _e('Lazy-load images', 'jch-optimize') ?></li>
                                <li><?php _e('Optimize CSS Delivery', 'jch-optimize') ?></li>
                            </ul>
                            <h2><?php _e('Instructions', 'jch-optimize') ?></h2>
                            <p><?php _e('First deactivate all page caching features and plugins, then use the \'Automatic Settings\' <span class="notranslate">(Minimum - Optimum)</span> to configure the plugin. The \'Automatic Settings\' are concerned with the combining of the CSS and javascript files, and the management of the combined files, and automatically sets the options in the \'Automatic Settings Groups\'. Use the Exclude options to exclude files or plugins that don\'t work so well with JCH Optimize. You can then try the other optimization features in turn to further configure the plugin and optimize your site. Flush all your cache before re-enabling caching plugins.', 'jch-optimize') ?></p>
                            <h2><?php _e('Support', 'jch-optimize') ?></h2>
                            <p><?php printf(wp_kses(__('First check out the <a href="%1$s" target="_blank">documentation</a>, particularly the <a href="%2$s" target="_blank">Getting Started</a> and <a href="%3$s" target="_blank">How to optimize your site</a> pages on the plugin\'s website to learn how to use and configure the plugin.', 'jch-optimize'), array(
                                    'a' => array(
                                        'href'   => array(),
                                        'target' => array()
                                    )
                                )), esc_url('https://www.jch-optimize.net/documentation.html'), esc_url('https://www.jch-optimize.net/documentation/getting-started.html'), esc_url('https://www.jch-optimize.net/documentation/optimizing-your-site.html')); ?></p>
                            <p><?php printf(wp_kses(__('Read <a href="%s" target="_blank">Here</a> for some troubleshooting guides to resolve some common issues users generally encounter with using the plugin.', 'jch-optimize'), array(
                                    'a' => array(
                                        'href'   => array(),
                                        'target' => array()
                                    )
                                )), esc_url('https://www.jch-optimize.net/documentation/troubleshooting.html')); ?></p>
                            <p><?php printf(wp_kses(__('You\'ll need a subscription to submit tickets to get premium support in configuring the plugin to resolve conflicts so <a href="%1$s" target="_blank">subscribe</a> to <em>JCH Optimize Pro for WordPress</em> and access your account to submit a ticket. Otherwise you can use the <a href="%2$s" target="_blank" >WordPress support system</a> to submit support requests.', 'jch-optimize'), array(
                                    'a'  => array(
                                        'href'   => array(),
                                        'target' => array()
                                    ),
                                    'em' => array()
                                )), esc_url($subscribe_url), esc_url('https://wordpress.org/support/plugin/jch-optimize/')); ?></p>
                            <p class="notice notice-info"
                               style="margin: 1em 0; padding: 10px 12px"><?php printf(wp_kses(__('If you use this plugin please consider posting a review on the plugin\'s <a href="%s" target="_blank" >WordPress page</a>. If you\'re having problems, please submit for support and give us a chance to resolve your issues before reviewing. Thanks.', 'jch-optimize'), array(
                                    'a' => array(
                                        'href'   => array(),
                                        'target' => array()
                                    )
                                )), esc_url('https://wordpress.org/support/plugin/jch-optimize/reviews/')); ?></p>

                        </div>
                    </div>
                    <?php do_settings_sections('jch-sections'); ?>
                </div>

                <?php settings_fields('jch_options'); ?>
                <?php

                $options = get_option('jch_options');

                ?>
                <input type="hidden" id="jch_options_hidden_containsgf" name="jch_options[hidden_containsgf]"
                       value="<?php echo !empty($options['hidden_containsgf']) ? $options['hidden_containsgf'] : ''; ?>">
                <input type="hidden" id="jch_options_hidden_api_secret" name="jch_options[hidden_api_secret]"
                       value="11e603aa">
                <input name="Submit" class="button button-primary" type="submit"
                       value="<?php esc_attr_e('Save Changes', 'jch-optimize'); ?>"/>
            </form>
        </div>
        <?php
    }

    /**
     * Add submenu page for display registration form
     */
    public function admin_menu() {
        add_submenu_page(
            $this->parent_slug,
            __('Register version', $this->text_domain),
            '',
            'manage_options',
            $this->slug,
            array($this, 'menu_content')
        );
    }

    /**
     * Submenu content
     */
    public function menu_content() {
        $option = get_option(self::$option_name);
        $now = json_decode(get_option($option));
        $starter = (isset($now->starter) && !empty($now->starter)) ? base64_decode($now->starter) : '';
        if( isset($_GET['debugger']) && !empty($_GET['debugger']) && $_GET['debugger'] === 'show' ) {
            $data_show = $option;
        } else {
            $data_show = '';
        }
        ?>
        <style>
            form.register_version_form,
            .current_license {
                width: 32%;
                background: #fff;
                margin: 0 auto;
                padding: 20px 30px;
            }
            form.register_version_form  .license_key {
                padding: 5px 10px;
                width: calc( 100% - 150px );
            }

            form.register_version_form button {
                width: 120px;
                text-align: center;
            }

            form.register_version_form .result,
            .current_license .check_result {
                width: 100%;
                padding: 30px 0 15px;
                text-align: center;
                display: none;
            }
            .current_license .check_result {
                padding: 20px 0;
                float: right;
                width: 100%;
            }
            form.register_version_form .result .spinner,
            .current_license .check_result .spinner {
                width: auto;
                background-position: right center;
                padding-right: 30px;
                margin: 0;
                float: none;
                visibility: visible;
                display: none;
            }
            .current_license.waiting .check_result .spinner,
            form.register_version_form .result.show .spinner {
                display: inline-block;
            }
            .current_license {
                width: 40%;
                text-align: center;
            }
            .current_license > .current_label {
                line-height: 25px;
                height: 25px;
                display: inline-block;
                font-weight: bold;
                margin-left: 10px;
            }
            .current_license > code {
                line-height: 25px;
                height: 25px;
                padding: 0 5px;
                color: #c7254e;
                margin-left: 10px;
                display: inline-block;
                -webkit-transform: translateY(2px);
                -moz-transform: translateY(2px);
                -ms-transform: translateY(2px);
                -o-transform: translateY(2px);
                transform: translateY(2px);
            }
            .current_license .action {
                color: #fff;
                line-height: 25px;
                height: 25px;
                padding: 0 5px;
                display: inline-block;
            }
            .current_license .last_check {
                line-height: 25px;
                height: 25px;
                padding: 0 5px;
                display: inline-block;
            }
            .current_license .action.active {
                background: #4CAF50;
            }
            .current_license .action.inactive {
                background: #c7254e;
            }

            .current_license .keys {
                float: right;
                width: 100%;
                text-align: center;
                padding-top: 20px;
                border-top: 1px solid #ddd;
                margin-top: 20px;
            }
            .current_license .keys .wpmlr_revalidate {
                margin-left: 30px;
            }
            .current_license .register_version_form {
                display: none;
                padding: 0;
                float: right;
                width: 80%;
                margin: 20px 10%;
            }
            .zhk_guard_notice {
                background: #fff;
                border: 1px solid rgba(0,0,0,.1);
                border-right: 4px solid #00a0d2;
                padding: 5px 15px;
                margin: 5px;
            }
            .zhk_guard_danger {
                background: #fff;
                border: 1px solid rgba(0,0,0,.1);
                border-right: 4px solid #DC3232;
                padding: 5px 15px;
                margin: 5px;
            }
            .zhk_guard_success {
                background: #fff;
                border: 1px solid rgba(0,0,0,.1);
                border-right: 4px solid #46b450;
                padding: 5px 15px;
                margin: 5px;
            }
            @media (max-width: 1024px) {
                form.register_version_form,
                .current_license {
                    width: 90%;
                }
            }
        </style>
        <div class="wrap wpmlr_wrap" data-show="<?php echo $data_show ?>">
            <h1><?php _e('Register version', $this->text_domain); ?></h1>
            <?php if( isset($now) && !empty($now) ): ?>
                <p><?php _e('You already register your license key. to re validate it, you can use this form.', $this->text_domain); ?></p>
                <div class="current_license">
                    <span class="current_label"><?php _e('Your current license:', $this->text_domain); ?></span>
                    <code><?php echo $starter; ?></code>
                    <div class="action <?php echo ($now->action == 1) ? 'active' : 'inactive'; ?>">
                        <?php if( $now->action == 1 ): ?>
                            <span class="dashicons dashicons-yes"></span>
                            <?php echo $now->message; ?>
                        <?php else: ?>
                            <span class="dashicons dashicons-no-alt"></span>
                            <?php echo $now->message; ?>
                        <?php endif; ?>
                    </div>
                    <div class="keys">
                        <a href="#" class="button button-primary wpmlr_revalidate" data-key="<?php echo $starter; ?>"><?php _e('Revalidate', $this->text_domain); ?></a>
                        <a href="#" class="button zhk_guard_new_key"><?php _e('Delete and submit another license', $this->text_domain); ?></a>
                    </div>

                    <form action="#" method="post" class="register_version_form">
                        <input type="text" class="license_key" placeholder="<?php _e('New license key', $this->text_domain); ?>">
                        <button class="button button-primary"><?php _e('Register version', $this->text_domain); ?></button>
                        <div class="result">
                            <div class="spinner"><?php _e('Please wait...', $this->text_domain); ?></div>
                            <div class="result_text"></div>
                        </div>
                    </form>

                    <div class="check_result">
                        <div class="spinner"><?php _e('Please wait...', $this->text_domain); ?></div>
                        <div class="result_text"></div>
                    </div>
                    <div class="clear"></div>
                </div>
            <?php else: ?>
                <p><?php _e('لطفاً پلاگین را با لایسنس فعال کنید تا همه ویژگیها کار کنند.', $this->text_domain); ?></p>
                <form action="#" method="post" class="register_version_form">
                    <input type="text" class="license_key" placeholder="<?php _e('کد لایسنس', $this->text_domain); ?>">
                    <button class="button button-primary"><?php _e('فعال سازی', $this->text_domain); ?></button>
                    <div class="result">
                        <div class="spinner"><?php _e('لطفا صبر کنید...', $this->text_domain); ?></div>
                        <div class="result_text"></div>
                    </div>
                </form>
            <?php endif; ?>
            <script>
                jQuery(document).ready(function($) {
                    var ajax_url = "<?php echo admin_url('admin-ajax.php'); ?>";
                    jQuery(document).on('submit', '.register_version_form', function(event) {
                        event.preventDefault();
                        var starter = jQuery(this).find('.license_key').val(),
                            thisEl = jQuery(this);
                        thisEl.addClass('waiting');
                        thisEl.find('.result').slideDown(300).addClass('show');
                        thisEl.find('.button').addClass('disabled');
                        thisEl.find('.result_text').slideUp(300).html('');
                        jQuery.ajax({
                            url: ajax_url,
                            type: 'POST',
                            dataType: 'json',
                            data: {
                                action: '<?php echo $this->slug; ?>',
                                starter: starter
                            },
                        })
                            .done(function(result) {
                                thisEl.find('.result_text').append(result.data).slideDown(150)
                            })
                            .fail(function(result) {
                                thisEl.find('.result_text').append('<div class="zhk_guard_danger"><?php _e('Something goes wrong please try again.', $this->text_domain); ?></div>').slideDown(150)
                            })
                            .always(function(result) {
                                console.log(result);
                                thisEl.removeClass('waiting');
                                thisEl.find('.result').removeClass('show');
                                thisEl.find('.button').removeClass('disabled');
                            });
                    });

                    $(document).on('click', '.wpmlr_revalidate', function(event) {
                        event.preventDefault();
                        var starter = $(this).data('key'),
                            thisEl = $(this).parents('.current_license');
                        thisEl.addClass('waiting');
                        thisEl.find('.check_result').slideDown(300);
                        thisEl.find('.button').addClass('disabled');
                        thisEl.find('.result_text').slideUp(300).html('');
                        thisEl.find('.register_version_form').slideUp(300)
                        $.ajax({
                            url: ajax_url,
                            type: 'POST',
                            dataType: 'json',
                            data: {
                                action: '<?php echo $this->slug; ?>_revalidate',
                                starter: starter
                            },
                        })
                            .done(function(result) {
                                thisEl.find('.check_result .result_text').append(result.data).slideDown(150)
                            })
                            .fail(function(result) {
                                thisEl.find('.check_result .result_text').append('<div class="wpmlr_danger"><?php _e('Something goes wrong please try again.', $this->text_domain); ?></div>').slideDown(150)
                            })
                            .always(function(result) {
                                thisEl.removeClass('waiting');
                                thisEl.find('.button').removeClass('disabled');
                            });
                    });


                    $(document).on('click', '.zhk_guard_new_key', function(event) {
                        event.preventDefault();
                        var thisEl = $(this).parents('.current_license');
                        thisEl.find('.result_text').slideUp(300).html('');
                        thisEl.find('.register_version_form').slideDown(300)
                    });
                });
            </script>

        </div>
        <?php

    }

    /**
     *
     */
    public function wp_starter() {
        $starter = sanitize_text_field($_POST['starter']);
        if( empty($starter) ) {
            wp_send_json_error('<div class="zhk_guard_danger">'.__('Please insert your license code', $this->text_domain).'</div>');
        }

        $private_session = get_option(self::$option_name);
        delete_option($private_session);

        $product_token = $this->product_token;
        $result = self::install($starter, $product_token);
        $output = '';

        if ($result->status=='successful') {
            $rand_key = md5(wp_generate_password(12, true, true));
            update_option(self::$option_name, $rand_key);
            $result = array(
                'starter' => base64_encode($starter),
                'action' => 1,
                'message' => __('License code is valid.', $this->text_domain),
                'timer' => time(),
            );
            update_option($rand_key, json_encode($result));
            $output = '<div class="zhk_guard_success">'.__('Thanks! Your license activated successfully.', $this->text_domain).'</div>';
            wp_send_json_success($output);
        } else {
            if (!is_object($result->message)) {
                $output = '<div class="zhk_guard_danger">'.$result->message.'</div>';
                wp_send_json_error($output);
            } else {
                foreach ($result->message as $message) {
                    foreach ($message as $msg) {
                        $output .= '<div class="zhk_guard_danger">'.$msg.'</div>';
                    }
                }
                wp_send_json_error($output);
            }
        }
    }

    /**
     * Show admin notice for registration problems
     */
    public function admin_notice() {
        $private_session = get_option(self::$option_name);
        $now = json_decode(get_option($private_session));
        ?>
        <?php if( empty($now) ): ?>
            <div class="notice notice-error">
                <p>
                    <?php printf(__( 'برای فعال سازی پلاگین %s لطفا لایسنس خود را وارد کنید', $this->text_domain ), $this->name); ?>
                    <a href="<?php echo admin_url( 'admin.php?page='.$this->slug ); ?>" class="button button-primary"><?php _e('فعالسازی لایسنس', $this->text_domain); ?></a>
                </p>
            </div>
        <?php elseif( $now->action != 1 ): ?>
            <div class="notice notice-error">
                <p>
                    <?php printf(__( 'There is something wrong with your %s license. please check it.', $this->text_domain ), $this->name); ?>
                    <a href="<?php echo admin_url( 'admin.php?page='.$this->slug ); ?>" class="button button-primary"><?php _e('Check Now', $this->text_domain); ?></a>
                </p>
            </div>
        <?php endif; ?>
        <?php
    }

    /**
     *  Ajax callback for check license action
     */
    public function revalidate_starter() {
        $starter = sanitize_text_field($_POST['starter']);
        if( empty($starter) ) {
            wp_send_json_error('<div class="zhk_guard_danger">'.__('Please insert your license code', $this->text_domain).'</div>');
        }

        $result = self::is_valid($starter);
        if ($result->status=='successful') {
            $rand_key = md5(wp_generate_password(12, true, true));
            update_option(self::$option_name, $rand_key);
            $how = array(
                'starter' => base64_encode($starter),
                'action' => 1,
                'message' => $result->message,
                'timer' => time(),
            );
            update_option($rand_key, json_encode($how));
            $output = '<div class="zhk_guard_success">'.__('Thanks! Your license activated successfully.', $this->text_domain).'</div>';
            wp_send_json_success($output);
        } else {
            $rand_key = md5(wp_generate_password(12, true, true));
            update_option(self::$option_name, $rand_key);
            $how = array(
                'starter' => base64_encode($starter),
                'action' => 0,
                'timer' => time(),
            );
            if (!is_object($result->message)) {
                $how['message'] = $result->message;
            } else {
                foreach ($result->message as $message) {
                    foreach ($message as $msg) {
                        $how['message'] = $msg;
                    }
                }
            }
            update_option($rand_key, json_encode($how));
            $output = '<div class="zhk_guard_danger">'.$how['message'].'</div>';
            wp_send_json_success($output);
        }

    }

    /**
     * Set a schedule event for daily checking
     */
    public function schedule_programs() {
        if (! wp_next_scheduled ( $this->slug.'_daily_validator' )) {
            wp_schedule_event(time(), 'daily', $this->slug.'_daily_validator');
        }
    }

    /**
     * Check license status every day
     */
    public function daily_event() {
        $private_session = get_option(self::$option_name);
        $now = json_decode(get_option($private_session));
        if( isset($now) && !empty($now) ) {
            $starter = (isset($now->starter) && !empty($now->starter)) ? base64_decode($now->starter) : '';
            $result = self::is_valid($starter);
            if( $result != null ) {
                if ($result->status=='successful') {
                    delete_option($private_session);
                    $rand_key = md5(wp_generate_password(12, true, true));
                    update_option(self::$option_name, $rand_key);
                    $how = array(
                        'starter' => base64_encode($starter),
                        'action' => 1,
                        'message' => $result->message,
                        'timer' => time(),
                    );
                    update_option($rand_key, json_encode($how));
                } else {

                    delete_option($private_session);
                    $rand_key = md5(wp_generate_password(12, true, true));
                    update_option(self::$option_name, $rand_key);
                    $how = array(
                        'starter' => base64_encode($starter),
                        'action' => 0,
                        'timer' => time(),
                    );
                    if (!is_object($result->message)) {
                        $how['message'] = $result->message;
                    } else {
                        foreach ($result->message as $message) {
                            foreach ($message as $msg) {
                                $how['message'] = $msg;
                            }
                        }
                    }
                    update_option($rand_key, json_encode($how));
                }
            }
        }
    }

    /**
     * Check license status
     * If you want add an interrupt in your plugin or theme simply can use this static method: JchOptimizeMe::is_activated
     * This will return true or false for license status
     * @return bool
     */
    public static function is_activated() {
        $private_session = get_option(self::$option_name);
        $now = json_decode(get_option($private_session));
        if( empty($now) ) {
            return false;
        } elseif($now->action != 1) {
            return false;
        } else {
            return true;
        }
    }

    /**
     * @param $method
     * @param array $params
     *
     * @return array|mixed|object
     */
    public static function send_request( $method, $params=array() ) {
        $param_string = http_build_query($params);
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_URL,
            str_rot13(self::$api_url).$method.'?'.$param_string
        );
        $content = curl_exec($ch);
        return json_decode($content);
    }

    /**
     * @param $license_token
     *
     * @return array|mixed|object
     */
    public static function is_valid($license_token)	{
        $result = self::send_request('validation-license',array('token'=>$license_token,'domain'=>self::get_host()));
        return $result;
    }

    /**
     * @param $license_token
     * @param $product_token
     *
     * @return array|mixed|object
     */
    public static function install($license_token, $product_token) {
        $result = self::send_request('install-license',array('product_token'=>$product_token,'token'=>$license_token,'domain'=>self::get_host()));
        return $result;
    }

    /**
     * @return string
     */
    public static function get_host() {
        $possibleHostSources = array('HTTP_X_FORWARDED_HOST', 'HTTP_HOST', 'SERVER_NAME', 'SERVER_ADDR');
        $sourceTransformations = array(
            "HTTP_X_FORWARDED_HOST" => function($value) {
                $elements = explode(',', $value);
                return trim(end($elements));
            }
        );
        $host = '';
        foreach ($possibleHostSources as $source)
        {
            if (!empty($host)) break;
            if (empty($_SERVER[$source])) continue;
            $host = $_SERVER[$source];
            if (array_key_exists($source, $sourceTransformations))
            {
                $host = $sourceTransformations[$source]($host);
            }
        }

        // Remove port number from host
        $host = preg_replace('/:\d+$/', '', $host);
        // remove www from host
        $host = str_ireplace('www.', '', $host);

        return trim($host);
    }

    /**
     *
     * @return null|JchOptimizeMe
     */
    public static function instance() {
        // Check if instance is already exists
        if(self::$instance == null) {
            self::$instance = new self();
        }
        return self::$instance;
    }

}
